import characterRepository from '#repositories/characterRepository'
import TileRepository from '#repositories/tileRepository'
import { BaseEvent } from '#application/base/baseEvent'
import { Tile } from '#entities/tile'

interface IPayload {}

export default class TileListEven extends BaseEvent {
  public listen(): void {
    this.socket.on('gm:tile:list', this.handleEvent.bind(this))
  }

  private async handleEvent(data: IPayload, callback: (response: Tile[]) => void): Promise<void> {
    const character = await characterRepository.getById(this.socket.characterId!)
    if (!character) return

    if (character.role !== 'gm') {
      return
    }

    // get all tiles
    const tiles = await TileRepository.getAll()
    callback(tiles)
  }
}
